module Feathr
  module Api

    class FeathrError < StandardError

      attr_accessor :status, :errors

      def initialize(status:, errors:)
        @status, @errors = status, errors
      end

      def to_s
        str = ""
        str += "Status #{ status }\n" unless status.to_s.empty?
        str += if errors.is_a? Hash
          errors.map{ |k, v| "#{ k }: #{ v }" }.join('; ')
        elsif errors.is_a? Array
          errors.join('; ')
        else
          errors.to_s
        end
      end

    end

  end
end
