module Feathr
  module Api

    class FeathrObject < Feathr::Api::FeathrEndpoint
      attr_accessor :data, :id

      api_path ''

      def initialize(data, id)
        @data = data
        @id   = id

        super()
      end

      def path
        [api_path, id].join('')
      end

      def full_path
        url = [client.config.base_url, path].join('/') + "/"
      end

      def as_json
        data.to_h
      end

      def self.nested(*resources)
        resources.each do |resource|
          define_method(resource) do
            ivar = "@#{ resource }"
            klass_name = resource.to_s.split('_').collect(&:capitalize).join
            klass = Object.const_get("Feathr::Api::#{ klass_name }")

            instance_variable_get(ivar) ||
            instance_variable_set(ivar, klass.new(prepended_path: path))
          end
        end
      end
    end

  end
end
