module Feathr
  class Config
    attr_accessor :scheme, :host, :api_key, :api_email, :api_password

    DEFAULT_SCHEME  = 'https'
    DEFAULT_HOST    = 'staging.qwil.co'
    DEFAULT_API_KEY = ''

    def initialize
      @scheme     = DEFAULT_SCHEME
      @host       = DEFAULT_HOST
      @api_key    = DEFAULT_API_KEY

      yield(self) if block_given?
    end

    def self.default
      @@default ||= Feathr::Config.new
    end

    def configure
      yield(self) if block_given?
    end

    def scheme=(scheme)
      # remove :// from scheme
      @scheme = scheme.sub(/:\/\//, '')
    end

    def host=(host)
      # remove http(s):// and anything after a slash
      @host = host.sub(/https?:\/\//, '').split('/').first
    end

    def base_url
      url = "#{ scheme }://#{ host }".sub(/\/+\z/, '')
    end
  end
end
